$AdfDhtmlMessagesPeer$$.prototype.$GetSubIdDomElement$ = function $$AdfDhtmlMessagesPeer$$$$$GetSubIdDomElement$$($msgType$$2_subElementId$$39$$) {
  var $clientId$$521_laf$$165$$ = this.$getComponent$().$getClientId$(), $domElement$$659_introEl_tableEl_tableElements$$ = $AdfAgent$$.$getAgent$().getElementById($clientId$$521_laf$$165$$), $msgIndex$$2_page$$260$$ = $AdfPage$$.$PAGE$, $clientId$$521_laf$$165$$ = $msgIndex$$2_page$$260$$.$getLookAndFeel$(), $dlgEl_docCmp$$ = $msgIndex$$2_page$$260$$.$findComponentByAbsoluteId$($msgIndex$$2_page$$260$$.$_documentClientId$), $docPeer$$ = $dlgEl_docCmp$$.$getPeer$(), $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ = 
  $docPeer$$.$isMessagesInline$(), $dlgEl_docCmp$$ = $docPeer$$.$getSubIdDomElement$($dlgEl_docCmp$$, "page.messageDialog");
  if ("ok" == $msgType$$2_subElementId$$39$$) {
    if ($childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$) {
      return null;
    }
    var $attrValue$$27_childElements$$14_dlgCmp$$ = $msgIndex$$2_page$$260$$.$findComponentByAbsoluteId$($dlgEl_docCmp$$.id);
    return $attrValue$$27_childElements$$14_dlgCmp$$.$getPeer$().$getSubIdDomElement$($attrValue$$27_childElements$$14_dlgCmp$$, "cancel_button");
  }
  $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ || ($domElement$$659_introEl_tableEl_tableElements$$ = $dlgEl_docCmp$$);
  $msgIndex$$2_page$$260$$ = 0;
  $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ = -1;
  "]" == $msgType$$2_subElementId$$39$$.charAt($msgType$$2_subElementId$$39$$.length - 1) && ($childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ = $msgType$$2_subElementId$$39$$.lastIndexOf("["), $msgIndex$$2_page$$260$$ = 1 * $msgType$$2_subElementId$$39$$.substring($childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ + 1, $msgType$$2_subElementId$$39$$.length - 1));
  if ("page." == $msgType$$2_subElementId$$39$$.substr(0, 5)) {
    $msgType$$2_subElementId$$39$$ = 0 < $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ ? $msgType$$2_subElementId$$39$$.substring(5, $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$) : $msgType$$2_subElementId$$39$$.substring(5);
    $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ = $clientId$$521_laf$$165$$.getStyleClass($AdfDhtmlMessagesPeer$$.$_MESSAGES_INTRO_CLASS$);
    $domElement$$659_introEl_tableEl_tableElements$$ = $AdfDomUtils$$.getElementsByClassName($domElement$$659_introEl_tableEl_tableElements$$, $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$);
    if (!$domElement$$659_introEl_tableEl_tableElements$$ || 0 == $domElement$$659_introEl_tableEl_tableElements$$.length) {
      return null;
    }
    if ("intro" == $msgType$$2_subElementId$$39$$) {
      return $domElement$$659_introEl_tableEl_tableElements$$[0];
    }
    $domElement$$659_introEl_tableEl_tableElements$$ = $domElement$$659_introEl_tableEl_tableElements$$[0].parentNode.getElementsByTagName("table");
    $domElement$$659_introEl_tableEl_tableElements$$ = $domElement$$659_introEl_tableEl_tableElements$$.length ? $domElement$$659_introEl_tableEl_tableElements$$[0] : null;
    if (!$domElement$$659_introEl_tableEl_tableElements$$) {
      return null;
    }
    $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ = $clientId$$521_laf$$165$$.getStyleClass($AdfDhtmlMessagesPeer$$.$_MESSAGES_GROUP_TITLE_CLASS$);
    if ($childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ = $AdfSubIdUtils$$.$getChildElementByAttributeValue$($domElement$$659_introEl_tableEl_tableElements$$, "class", $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$)) {
      return null;
    }
  } else {
    $msgType$$2_subElementId$$39$$ = 0 < $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ ? $msgType$$2_subElementId$$39$$.substring(0, $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$) : $msgType$$2_subElementId$$39$$;
    $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ = $clientId$$521_laf$$165$$.getStyleClass($AdfDhtmlMessagesPeer$$.$_MESSAGES_GROUP_TITLE_CLASS$);
    $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$ = $AdfSubIdUtils$$.$getChildElementByAttributeValue$($domElement$$659_introEl_tableEl_tableElements$$, "class", $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$);
    if (!$childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$) {
      return $domElement$$659_introEl_tableEl_tableElements$$;
    }
    for ($domElement$$659_introEl_tableEl_tableElements$$ = $childEl_grpTitleCSS_introCSS$$1_isInline_openBracket$$1$$.parentNode;"TABLE" != $domElement$$659_introEl_tableEl_tableElements$$.nodeName && $domElement$$659_introEl_tableEl_tableElements$$.parentNode;) {
      $domElement$$659_introEl_tableEl_tableElements$$ = $domElement$$659_introEl_tableEl_tableElements$$.parentNode;
    }
  }
  "summary" == $msgType$$2_subElementId$$39$$ ? $attrValue$$27_childElements$$14_dlgCmp$$ = $clientId$$521_laf$$165$$.getStyleClass($AdfDhtmlMessagesPeer$$.$_MESSAGES_TYPE_CLASS$) : "detail" == $msgType$$2_subElementId$$39$$ && ($attrValue$$27_childElements$$14_dlgCmp$$ = $clientId$$521_laf$$165$$.getStyleClass($AdfDhtmlMessagesPeer$$.$_MESSAGES_DETAIL_CLASS$));
  if (!$attrValue$$27_childElements$$14_dlgCmp$$) {
    return null;
  }
  if (0 == $msgIndex$$2_page$$260$$) {
    return $AdfSubIdUtils$$.$getChildElementByAttributeValue$($domElement$$659_introEl_tableEl_tableElements$$, "class", $attrValue$$27_childElements$$14_dlgCmp$$);
  }
  $attrValue$$27_childElements$$14_dlgCmp$$ = $AdfSubIdUtils$$.$getChildElementsByAttributeValue$($domElement$$659_introEl_tableEl_tableElements$$, "class", $attrValue$$27_childElements$$14_dlgCmp$$);
  return $msgIndex$$2_page$$260$$ < $attrValue$$27_childElements$$14_dlgCmp$$.length ? $attrValue$$27_childElements$$14_dlgCmp$$[$msgIndex$$2_page$$260$$] : null;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlMessagesPeer.prototype.GetSubIdDomElement", {$GetSubIdDomElement$:$AdfDhtmlMessagesPeer$$.prototype.$GetSubIdDomElement$});
$AdfDhtmlMessagesPeer$$.prototype.$GetBestMatchSubId$ = function $$AdfDhtmlMessagesPeer$$$$$GetBestMatchSubId$$($domElement$$660$$) {
  var $clazz$$6_isTypeElem$$1_rootElem$$11$$ = $domElement$$660$$.getAttribute("class"), $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ = $AdfPage$$.$PAGE$, $candidateElements$$1_compLvlRegEx_laf$$166$$ = $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$.$getLookAndFeel$(), $agent$$809_isPageLevelMsgElement$$ = $AdfAgent$$.$getAgent$(), $detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$ = $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$.$findComponentByAbsoluteId$($dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$.$_documentClientId$), 
  $docPeer$$1_typeCSS$$1$$ = $detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$.$getPeer$();
  if (!$docPeer$$1_typeCSS$$1$$.$isMessagesInline$() && ($detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$ = $docPeer$$1_typeCSS$$1$$.$getSubIdDomElement$($detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$, "page.messageDialog"), $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ = $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$.$findComponentByAbsoluteId$($detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$.id), $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$.$getPeer$().$getSubIdDomElement$($dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$, 
  "cancel_button") == $domElement$$660$$)) {
    return "ok";
  }
  var $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ = $candidateElements$$1_compLvlRegEx_laf$$166$$.getStyleClass($AdfDhtmlMessagesPeer$$.$_MESSAGES_INTRO_CLASS$), $curElem_isIntroElem$$1$$ = (new RegExp($dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$.replace("|", "\\|"))).test($clazz$$6_isTypeElem$$1_rootElem$$11$$), $detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$ = $candidateElements$$1_compLvlRegEx_laf$$166$$.getStyleClass($AdfDhtmlMessagesPeer$$.$_MESSAGES_DETAIL_CLASS$), 
  $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ = !$curElem_isIntroElem$$1$$ && (new RegExp($detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$.replace("|", "\\|"))).test($clazz$$6_isTypeElem$$1_rootElem$$11$$), $docPeer$$1_typeCSS$$1$$ = $candidateElements$$1_compLvlRegEx_laf$$166$$.getStyleClass($AdfDhtmlMessagesPeer$$.$_MESSAGES_TYPE_CLASS$), $clazz$$6_isTypeElem$$1_rootElem$$11$$ = !$dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ && (new RegExp($docPeer$$1_typeCSS$$1$$.replace("|", 
  "\\|"))).test($clazz$$6_isTypeElem$$1_rootElem$$11$$);
  if (!$curElem_isIntroElem$$1$$ && !$dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ && !$clazz$$6_isTypeElem$$1_rootElem$$11$$) {
    return null;
  }
  if ($curElem_isIntroElem$$1$$) {
    return "page.intro";
  }
  for (var $clazz$$6_isTypeElem$$1_rootElem$$11$$ = $agent$$809_isPageLevelMsgElement$$.getElementById(this.$getComponent$().$getClientId$()), $agent$$809_isPageLevelMsgElement$$ = null, $curElem_isIntroElem$$1$$ = $domElement$$660$$, $step$$9$$ = 15, $pageLvlRegEx$$ = new RegExp($candidateElements$$1_compLvlRegEx_laf$$166$$.getStyleClass("af|messages::message-list-page").replace("|", "\\|")), $candidateElements$$1_compLvlRegEx_laf$$166$$ = new RegExp($candidateElements$$1_compLvlRegEx_laf$$166$$.getStyleClass("af|message::component-messages-list-container").replace("|", 
  "\\|"));0 < $step$$9$$ && $curElem_isIntroElem$$1$$ != $clazz$$6_isTypeElem$$1_rootElem$$11$$ && null != $curElem_isIntroElem$$1$$;) {
    var $curElemClazz$$ = $curElem_isIntroElem$$1$$.getAttribute("class");
    if ($pageLvlRegEx$$.test($curElemClazz$$)) {
      $agent$$809_isPageLevelMsgElement$$ = !0;
      break;
    } else {
      if ($candidateElements$$1_compLvlRegEx_laf$$166$$.test($curElemClazz$$)) {
        $agent$$809_isPageLevelMsgElement$$ = !1;
        break;
      }
    }
    $curElem_isIntroElem$$1$$ = $curElem_isIntroElem$$1$$.parentNode;
    $step$$9$$--;
  }
  if (null != $agent$$809_isPageLevelMsgElement$$) {
    for ($candidateElements$$1_compLvlRegEx_laf$$166$$ = $AdfSubIdUtils$$.$getChildElementsByAttributeValue$($curElem_isIntroElem$$1$$, "class", 1 == $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ ? $detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$ : $docPeer$$1_typeCSS$$1$$), $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ = (1 == $agent$$809_isPageLevelMsgElement$$ ? "page." : "") + ($dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ ? "detail" : "summary"), $detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$ = 
    0;$detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$ < $candidateElements$$1_compLvlRegEx_laf$$166$$.length;$detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$++) {
      if ($candidateElements$$1_compLvlRegEx_laf$$166$$[$detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$] == $domElement$$660$$) {
        return $dlgCmp$$1_introCSS$$2_isDetailElem$$1_page$$261_subId$$55$$ + "[" + $detailCSS$$1_dlgEl$$1_docCmp$$1_i$$762$$ + "]";
      }
    }
  }
  return null;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlMessagesPeer.prototype.GetBestMatchSubId", {$GetBestMatchSubId$:$AdfDhtmlMessagesPeer$$.prototype.$GetBestMatchSubId$});
